import 'package:flutter/material.dart';

class I18NMap {

  ///[Locale] determines the [language] of the set
  ///[Map<String,String>] forms one [language set]
  ///The Keys of a [language set] must be consistent throughout all sets
  ///and therefore existent in all sets
  Map<Locale, Map<String, String>> languageSets;

  ///bool [valid] is used to indicate if the language sets are valid.
  ///For the language sets to be valid, the same keys have to be present
  ///in every language set
  bool valid;

  I18NMap(Map<Locale, Map<String, String>> languageSets) {
    this.languageSets = languageSets;
    this.valid = _checkIfValid();
  }

  ///Checks if [Keys] of every [language set] can be found in eachother
  bool _checkIfValid() {
    if (this.languageSets.length >= 0) {
      List<Map<String, String>> _languageSets = languageSets.values.toList();
      List<String> _keys = _languageSets[0].keys.toList();
      for (Map<String, String> languageSet in _languageSets) {
        List<String> _currentKeys = languageSet.keys.toList();
        for (int x = 0; x < _keys.length; x++) {
          if (!_keys.contains(_currentKeys[x])) {
            return false;
          } 
        }
        _keys = languageSet.keys.toList();
      }
        return true;
    } else {
      return false;
    }
  }
}
